;##################################################################
;
;   Phoenix for TI-83 Plus - MirageOS version
;
;   Programmed by Patrick Davidson (pad@calc.org)
;        
;   Copyright 2004 by Patrick Davidson.  This software may be freely
;   modified and/or copied with no restrictions.  There is no warranty.
;
;   This file was last updated September 1, 2002.
;
;##################################################################     

 .binarymode TI8X
 .variablename PHOENIX

#define __TI83__
#define __MIRAGE__
#define TI83P

#include "ti83plus.inc"
#include "mirage.inc"
#include "usb8xtsm.inc"
#include "keys.i"

backup_storage  =SavesScreen
TEXT_MEM= SavesScreen+256
GFX_AREA        =plotsscreen   
GRAPH_MEM       =plotsscreen

D_ZT_STR        =_puts
D_HL_DECI       =_disphl
TX_CHARPUT      =_putc
CLEARLCD        =_ClrLCDFull
CURSOR_ROW      =currow
CURSOR_COL      =curcol
ionDetect       =idetect

#define ROM_CALL(kewl_routinez) bcall(kewl_routinez)

        .org    $9D93
        .db     $BB,$6D
        ret
        .db     1
        .db     %00000000,%01001000
        .db     %00011000,%10010010
        .db     %00011000,%00000000
        .db     %00011000,%00000000
        .db     %00011000,%10000100
        .db     %00011000,%01000010
        .db     %00000000,%00000000
        .db     %00000000,%00010000
        .db     %10000001,%00100100
        .db     %10000001,%00000000
        .db     %10000001,%00000000
        .db     %10011001,%00000000
        .db     %10100101,%00000000
        .db     %11000011,%00000000
        .db     %10000001,%00000000

#include "phoenixz.i"

        .db     "Phoenix for MirageOS",0
USBDriverCall = appbackupscreen+700

start:  
	ld	a,0FFh
	ld	(appbackupscreen+500),a
	xor	a
	ld	(USBActive),a
	ld	(USBLoaded),a
	U_CALL_INIT(ucb)
	jp	c,usbskip

	U_CALL(GetVersion)
	ld	de,0Bh
	or	a
	sbc	hl,de
	jp	c,usbskip			;Requires version 0.11+

	ld	a,1
	ld	(USBLoaded),a

	ld	a,(USBSetup)
	or	a
	jr	z,usbskip

	ld	hl,appbackupscreen
	U_CALL(DriverInit)
	jr	c,usbskip
	ld	hl,appbackupscreen+256
	ld	de,savesscreen
	U_CALL(PadInit)
	jp	c,usbskip
	ld	a,1
	ld	(USBActive),a
	U_CALL(PadStart)
	

	
usbskip:
        ld      de,backup_storage       ; Save data after GRAPH_MEM
        ld      hl,GFX_AREA+768
        ld      bc,256
        ldir
        call    main
        ld      (iy+13),6
restore_memory:
        ld      hl,backup_storage      ; Restore data after GRAPH_MEM
        ld      de,GFX_AREA+768
        ld      bc,256
        ldir
        ret

GET_KEY:
        bcall(_getcsc)
        ret


DownTXT:
	.db	"Down?",0
RightTXT:
	.db	"Right?",0
LeftTXT:
	.db	"Left?",0
UpTXT:
	.db	"Up?",0
FireTXT:
	.db	"Fire?",0

ucb:
	ld	c,0FFh
	ld	hl,appbackupscreen
	ld	a,(downkey)
	ld	e,a
	ld	d,0
	add	hl,de
	ld	a,(downkey+1)
	and	(hl)
	jr	z,skip1
	res	0,c
skip1:
	ld	hl,appbackupscreen
	ld	a,(leftkey)
	ld	e,a
	ld	d,0
	add	hl,de
	ld	a,(leftkey+1)
	and	(hl)
	jr	z,skip2
	res	1,c
skip2:	
	ld	hl,appbackupscreen
	ld	a,(rightkey)
	ld	e,a
	ld	d,0
	add	hl,de
	ld	a,(rightkey+1)
	and	(hl)
	jr	z,skip3
	res	2,c
skip3:
	ld	hl,appbackupscreen
	ld	a,(upkey)
	ld	e,a
	ld	d,0
	add	hl,de
	ld	a,(upkey+1)
	and	(hl)
	jr	z,skip4
	res	3,c
skip4:
	ld	hl,appbackupscreen
	ld	a,(firekey)
	ld	e,a
	ld	d,0
	add	hl,de
	ld	a,(firekey+1)
	and	(hl)
	jr	z,skip5
	res	5,c
skip5:
	ld	a,c
	ld	(appbackupscreen+500),a
	ret
;############## Include remainder of game files

#include "main12.asm"
#include "extlev12.asm"
#include "exchange.asm"
#include "lib12.asm"
#include "lib.asm"
#include "title12.asm"
#include "disp12.asm"
#include "drwspr.asm"
#include "player12.asm"
#include "shoot.asm"
#include "bullets.asm"
#include "enemies.asm"
#include "init.asm"
#include "enemyhit.asm"
#include "collide.asm"
#include "ebullets.asm"
#include "hityou.asm"
#include "shop12.asm"
#include "helper.asm"
#include "eshoot.asm"
#include "score12.asm"
#include "emove.asm"
#include "images.asm"
#include "data.asm"
#include "levels.asm"
#include "vars.asm"

        .end
